package animatlab.kodamat.core.adds;

/**
 * 
 * Node in a ADD
 * 
 * @author Thomas Degris, Tomas Simovic
 * @param <T>
 *          type of data stored in the data structure
 * 
 */
public class ADDNode<T> {
	/**
	 * 
	 * ADD owning this node
	 * 
	 */
	protected ADD<T> add;

	/**
	 * 
	 * Flag to indicate if this node is terminal or not
	 * 
	 */
	public final boolean terminal;

	/**
	 * 
	 * Value of the node
	 * 
	 */
	public String value = null;

	/**
	 * 
	 * Constructor
	 * 
	 * @param add
	 *          ADD owning this node
	 * @param terminal
	 *          flag to indicate if this node is terminal or not
	 * 
	 */
	public ADDNode(ADD<T> add, boolean terminal) {
		this.add = add;
		this.terminal = terminal;
	}

	/**
	 * 
	 * Value accessor method
	 * 
	 * @return value
	 */
	public String getValue() {
		return value;
	}

	/**
	 * 
	 * Value set method
	 * 
	 * @param value
	 */
	public void setValue(String value) {
		this.value = value;
	}
}
