package animatlab.kodamat.core.adds;

import animatlab.kodamat.core.io.DataContainer;

/**
 * 
 * Terminal node in ADDs
 * 
 * @author Thomas Degris, Tomas Simovic
 * @param <T>
 *          type of the data contained at the leaf
 * 
 */
public class TerminalNode<T> extends ADDNode<T> implements DataContainer<T> {
	/**
	 * 
	 * Data contained by this terminal node
	 * 
	 */
	T data;

	/**
	 * 
	 * Constructor
	 * 
	 * @param add
	 *          ADD owning this node
	 * @param data
	 *          data stored at the leaf
	 * 
	 */
	public TerminalNode(ADD<T> add, T data) {
		super(add, true);
		this.data = data;
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		if (data == null) {
			return "null";
		}
		return data.toString();
	}

	/**
	 * Set the data
	 * 
	 * @param data
	 *          the data to set
	 */
	public void set(T data) {
		this.data = data;
	}

	/**
	 * @see animatlab.kodamat.core.io.DataContainer#get()
	 */
	public T get() {
		return data;
	}
}
