package animatlab.kodamat.core.adds.tests;

import static animatlab.kodamat.core.io.XmlUtils.getRoot;
import junit.framework.TestCase;

import org.w3c.dom.Element;

import animatlab.kodamat.core.adds.ADD;
import animatlab.kodamat.core.io.DataLoadingPolicy;
import animatlab.kodamat.core.io.IToXml;
import animatlab.kodamat.core.io.XmlUtils;

/**
 * 
 * Test cases for ADDs
 * 
 * @author Thomas Degris
 * 
 */
public class TestADDs extends TestCase {
	/**
	 * 
	 * Build a tree from a xml definition
	 * 
	 * @param xmlString
	 *          the xml definition of the tree
	 * 
	 * @return the new tree
	 * 
	 */
	private ADD<String> getAdd(String xmlString) {
		return new ADD<String>(getRoot(xmlString),
				DataLoadingPolicy.stringLoadingPolicy);
	}

	/**
	 * 
	 * Test expand against xml loading
	 * 
	 */
	public void testXmlLoadingSaving() {
		String xmlString = "<cud:add>" + "  <cud:decision id='0' variable='0'/>"
				+ "  <cud:leaf id='1' data='world'/>"
				+ "  <cud:edge from='0' to='1' side='left'/>"
				+ "  <cud:edge from='0' to='1' side='right'/>" + "</cud:add>";
		ADD<String> add = getAdd(xmlString);

		xmlString = XmlUtils.toXmlString(add, new IToXml.IToXmlPolicy<String>() {
			public void toXml(Element parent, String data) {
				parent.setAttribute("data", data);
			}
		});
		assertEquals(getAdd(xmlString).toString(), add.toString());
	}

}
