/*
 * 
 * Created on 16 aout 2005
 *
 */
package animatlab.kodamat.core.conditions;

import java.util.Random;

import org.w3c.dom.Node;

import animatlab.kodamat.core.utils.Context;

/**
 * 
 * And operator for state conditions
 * 
 * @author Thomas Degris
 * 
 */
public class AndCondition extends OperatorCondition {

	/**
	 * 
	 * Xml name of this operator
	 * 
	 */
	public static final String OPERATOR_AND_NAME = "and";

	/**
	 * 
	 * Constructor
	 * 
	 */
	public AndCondition() {
		super(OPERATOR_AND_NAME);
	}

	/**
	 * 
	 * Constructor
	 * 
	 * @param xmlNode
	 *          the xml node to build the condition from
	 * 
	 */
	public AndCondition(Node xmlNode) {
		super(xmlNode, OPERATOR_AND_NAME);
	}

	/**
	 * @see animatlab.kodamat.core.conditions.OperatorCondition#applyOperator(boolean,
	 *      boolean)
	 */
	@Override
	protected boolean applyOperator(boolean arg01, boolean arg02) {
		return arg01 && arg02;
	}

	/**
	 * @see animatlab.kodamat.core.conditions.IStateCondition#setToTrue(java.util.Random,
	 *      Context)
	 */
	public void setToTrue(Random random, Context state) {
		for (IStateCondition arg : argSet) {
			arg.setToTrue(random, state);
		}
	}
}
