/*
 * 
 * Created on 16 aout 2005
 *
 */
package animatlab.kodamat.core.conditions;

import java.util.Random;

import org.w3c.dom.Node;

import animatlab.kodamat.core.utils.Context;

/**
 * 
 * Or operator for state conditions
 * 
 * @author Thomas Degris
 * 
 */
public class OrCondition extends OperatorCondition {

	/**
	 * 
	 * Xml name of this operator
	 * 
	 */
	public static final String OPERATOR_OR_NAME = "or";

	/**
	 * 
	 * Constructor
	 * 
	 * @param xmlNode
	 *          the xml node to build the condition from
	 * 
	 */
	public OrCondition(Node xmlNode) {
		super(xmlNode, OPERATOR_OR_NAME);
	}

	/**
	 * @see animatlab.kodamat.core.conditions.OperatorCondition#applyOperator(boolean,
	 *      boolean)
	 */
	@Override
	protected boolean applyOperator(boolean arg01, boolean arg02) {
		return (arg01 || arg02);
	}

	/**
	 * @see animatlab.kodamat.core.conditions.IStateCondition#setToTrue(java.util.Random,
	 *      Context)
	 */
	public void setToTrue(Random random, Context state) {
		Integer selected = random.nextInt((int) (Math.pow(2, argSet.size()) - 1)) + 1;
		String mask = Integer.toBinaryString(selected);
		for (int index = 0; index < argSet.size(); index++) {
			if ((index >= (argSet.size() - mask.length()))
					&& (mask.charAt(index - (argSet.size() - mask.length())) == '1')) {
				argSet.get(index).setToTrue(random, state);
			}
		}
	}

}
