/*
 * 
 * Created on Dec 29, 2005
 *
 */
package animatlab.kodamat.core.functions;

import animatlab.kodamat.core.utils.Context;

/**
 * 
 * Interface for a structure classifying vector of values of T
 * 
 * @param <T>
 *          type of the result of the function
 * 
 * @author Thomas Degris
 * 
 */
public interface IFunction<T> {

	/**
	 * 
	 * Classify an example
	 * 
	 * @param state
	 *          the example to classify
	 * @return the result of the classification
	 * 
	 */
	public T classify(Context state);

	/**
	 * 
	 * @return the number of nodes in this structure
	 * 
	 */
	public int numberOfNodes();

	/**
	 * 
	 * Clone this function
	 * 
	 * @return a clone of this function
	 * 
	 */
	public IFunction<T> clone();
}
