package animatlab.kodamat.core.functions;

import java.util.Set;

import animatlab.kodamat.core.io.DataContainer;
import animatlab.kodamat.core.utils.Context;
import animatlab.kodamat.core.utils.Variable;

/**
 * 
 * Partition of a factored function
 * 
 * @param <T>
 *          type of the result of the function
 * 
 * @author Thomas Degris
 * 
 */
public interface IPartition<T> extends DataContainer<T> {
	/**
	 * 
	 * @return the scope of this partition
	 * 
	 */
	public Set<Variable> scope();

	/**
	 * 
	 * @return the context of the partition
	 * 
	 */
	public Context getContext();
}