package animatlab.kodamat.core.io;

/**
 * 
 * Interface used to convert a container into a xml string, dot string or
 * something else
 * 
 * @author Thomas Degris
 * @param <T>
 *          type of the container
 * 
 */
public interface IContainerToString<T> {
	/**
	 * 
	 * Convert the container from a default string
	 * 
	 * @param container
	 *          the container to convert
	 * @param defaultString
	 *          the default string obtained from the container
	 * 
	 * @return the string corresponding from the policy
	 * 
	 */
	String containerToString(T container, String defaultString);
}
