package animatlab.kodamat.core.proba;

/**
 * 
 * Learning probabilities able to return the number of exemples from which the
 * probability has been learned
 * 
 * @param <T>
 *          type associated with the probabilities
 * 
 * @author Thomas Degris
 * 
 */
public interface ILearningProbabilities<T> extends IProbabilities<T> {
	/**
	 * 
	 * @return the number of examples added to this database
	 * 
	 */
	public int getNumberOfExamples();

	/**
	 * 
	 * Get the number of times a value occured
	 * 
	 * @param value
	 *          the value to look at
	 * @return the number of times the value occurs in the sample
	 * 
	 */
	public int getNumberOfExamples(T value);
}
