/*
 * 
 * Created on 24 dec. 2005
 *
 */
package animatlab.kodamat.core.proba;

import java.util.Set;

/**
 * 
 * Interface to access to a probabilities distribution
 * 
 * @param <T>
 *          type associated with the probabilities
 * 
 * @author Thomas Degris
 * 
 */
public interface IProbabilities<T> {
	/**
	 * 
	 * Namespace used in xml file to represent a probability
	 * 
	 */
	final static public String NAMESPACE = "spi";

	/**
	 * 
	 * @return the value predicted with the best probability
	 * 
	 */
	public T getBest();

	/**
	 * 
	 * Get the probability associated with one value
	 * 
	 * @param value
	 *          the value to get the probability from
	 * 
	 * @return the probability of corresponding to the value
	 * 
	 */
	public double getProbability(T value);

	/**
	 * 
	 * @return the set of value with strictly positive probability
	 * 
	 */
	public Set<T> getValueSet();
}
