package animatlab.kodamat.core.rules;

import animatlab.kodamat.core.trees.Leaf;
import animatlab.kodamat.core.utils.Context;

/**
 * 
 * Rule associated to a leaf in a tree
 * 
 * @author Thomas Degris
 * @param <T>
 *          type pointed by this rule
 * 
 */
public class LeafRule<T> extends Rule<T> {
	/**
	 * 
	 * Leaf pointed by this rule
	 * 
	 */
	final private Leaf<T> leaf;

	/**
	 * 
	 * Constructor
	 * 
	 * @param leaf
	 *          leaf pointed by this rule
	 * 
	 */
	public LeafRule(Leaf<T> leaf) {
		super();
		this.leaf = leaf;
	}

	/**
	 * @see animatlab.kodamat.core.functions.IPartition#getContext()
	 */
	public Context getContext() {
		return leaf.getContext();
	}

	/**
	 * 
	 * Set the value pointed by this rule
	 * 
	 * @param data
	 *          the data to set
	 * 
	 */
	public void set(T data) {
		assert (false);
	}

	/**
	 * @see animatlab.kodamat.core.io.DataContainer#get()
	 */
	public T get() {
		return leaf.get();
	}
}
