package animatlab.kodamat.core.trees;

/**
 * 
 * Interface used to listen event about the creation and destruction of leaves
 * in a tree
 * 
 * @author Thomas Degris
 * 
 */
public interface LeafListener {
	/**
	 * 
	 * Called when a leaf is created
	 * 
	 * @param leaf
	 *          the leaf concerned by the event
	 * 
	 */
	public void leafIsCreated(Leaf<?> leaf);

	/**
	 * 
	 * Called when a leaf is removed
	 * 
	 * @param leaf
	 *          the leaf concerned by the event
	 * 
	 */
	public void leafIsRemoved(Leaf<?> leaf);
}
