package animatlab.kodamat.core.trees;

import java.util.Collection;

/**
 * 
 * Policy to merge a set of leaves together
 * 
 * @param <T>
 *          data stored at the leaves
 * @author Thomas Degris
 * 
 */
public interface MergeLeavesPolicy<T> {
	/**
	 * 
	 * Merge the set of leaves into one set
	 * 
	 * @param vertexSet
	 *          the set of leaves to merge
	 * 
	 * @return the leaf resulting of the merge (may be a leaf belonging to the
	 *         input set)
	 * 
	 */
	Vertex<T> merge(Collection<Vertex<T>> vertexSet);
}
