/*
 * 
 * Created on 14 sept. 2005
 *
 */
package animatlab.kodamat.problems.generated.syntheticmdps;

import animatlab.kodamat.core.proba.IProbabilities;
import animatlab.kodamat.core.trees.DNode;
import animatlab.kodamat.core.trees.Leaf;
import animatlab.kodamat.core.trees.Tree;
import animatlab.kodamat.core.utils.Variable;
import animatlab.kodamat.reinforcementlearning.model.forest.StaticForest;

/**
 * 
 * Class for generation a best case problem with all the transitions noisy
 * 
 * @author Thomas Degris
 * 
 */
public class NoisyLinearProblem extends SyntheticMDPsProblem {

	/**
	 * 
	 * Name of the bestcase problem
	 * 
	 */
	public static final String NOISYCASE_PROBLEM_NAME = "noisycase";

	/**
	 * 
	 * Constructor
	 * 
	 */
	public NoisyLinearProblem() {
		super(NOISYCASE_PROBLEM_NAME);
	}

	/**
	 * @see animatlab.kodamat.problems.generated.ForestGeneration#getVariableActionCptNode(animatlab.kodamat.reinforcementlearning.model.forest.StaticForest,
	 *      java.lang.String, animatlab.kodamat.core.utils.Variable)
	 */
	@Override
	protected Tree<IProbabilities<String>> getVariableActionCptNode(
			StaticForest forest, String action, Variable variable) {
		Tree<IProbabilities<String>> result = new Tree<IProbabilities<String>>();
		int actionIndex = Integer.parseInt(action);
		assert (noise > 0);
		if (getIndex(variable) < actionIndex) {
			DNode<IProbabilities<String>> dnode = result.getRoot().replace(variable);
			createBinaryProbaLeaf(dnode.addLeaf("false"), "false");
			createBinaryProbaLeaf(dnode.addLeaf("true"), "true");
			return result;
		}
		if (getIndex(variable) > actionIndex) {
			createBinaryProbaLeaf((Leaf<IProbabilities<String>>) result.getRoot(),
					"false");
			return result;
		}

		Leaf<IProbabilities<String>> currentLeaf = (Leaf<IProbabilities<String>>) result
				.getRoot();
		createBinaryProbaLeaf(currentLeaf, "true");
		for (int variableIndex = 0; variableIndex < actionIndex; variableIndex++) {
			Variable currentVariable = getVariable(variableIndex);
			DNode<IProbabilities<String>> dnode = currentLeaf
					.replace(currentVariable);
			createBinaryProbaLeaf(dnode.addLeaf("false"), "false");
			currentLeaf = dnode.addLeaf("true");
			createBinaryProbaLeaf(currentLeaf, "true");
		}
		return result;
	}

}
