package animatlab.kodamat.problems.generated.sysadmin;

import animatlab.kodamat.core.io.XmlUtils;
import animatlab.kodamat.core.proba.IProbabilities;
import animatlab.kodamat.core.trees.Tree;
import animatlab.kodamat.core.utils.Variable;
import animatlab.kodamat.reinforcementlearning.model.forest.StaticForest;

/**
 * 
 * All the machines are disconnected
 * 
 * @author Thomas Degris
 * 
 */
public class Disconnected extends SysAdminProblem {
	/**
	 * 
	 * Constructor
	 * 
	 */
	public Disconnected() {
		super("disconnected");
	}

	/**
	 * @see animatlab.kodamat.problems.generated.ForestGeneration#getVariableActionCptNode(animatlab.kodamat.reinforcementlearning.model.forest.StaticForest,
	 *      java.lang.String, animatlab.kodamat.core.utils.Variable)
	 */
	@Override
	protected Tree<IProbabilities<String>> getVariableActionCptNode(
			StaticForest forest, String action, Variable variable) {
		if (action.equals(extractActionName(variable.variable))) {
			return createLeafTree(forest, "W");
		}
		String treeTemplate = "<dtr:dnode variable='" + variable.variable + "'>"
				+ "  <dtr:leaf value='D'/>" + "  <dtr:leaf value='W'/>"
				+ "</dtr:dnode>";
		Tree<IProbabilities<String>> tree = new Tree<IProbabilities<String>>(
				XmlUtils.getRoot(treeTemplate), null);
		setProba(tree, "W", 0.75, variable);
		setProba(tree, "D", 0.0, variable);
		return tree;
	}
}
