/*
 * 
 * Created on 8 janv. 2006
 *
 */
package animatlab.kodamat.reinforcementlearning.agent;

import java.util.List;

import animatlab.kodamat.core.io.ILog;
import animatlab.kodamat.core.utils.Context;

/**
 * 
 * IncrementalAgent to run in Problems
 * 
 * @author Thomas Degris
 * 
 */
public interface IAgent extends ILog {
	/**
	 * 
	 * Get the next action to try for the agent
	 * 
	 * @param time
	 *          current time in the environment
	 * @param state
	 *          the current state of the agent
	 * @param reward
	 *          the last reward received by the agent
	 * 
	 * @return the action decided by the agent
	 * 
	 */
	String getAction(int time, Context state, List<Double> reward);
}
