package animatlab.kodamat.reinforcementlearning.core;

import java.util.List;

import animatlab.kodamat.core.utils.Context;

/**
 * 
 * Interface to listen steps of the running problem
 * 
 */
public interface IStepListener {
	/**
	 * 
	 * Step to listen
	 * 
	 * @param time
	 *          current time of the experiment
	 * @param currentState
	 *          the current state of the agent
	 * @param actionChoosen
	 *          the action choosen by the agent in the current state
	 * @param nextState
	 *          next state of the agent
	 * @param lastReward
	 *          last reward received by the agent
	 * 
	 */
	void listenStep(int time, Context currentState, String actionChoosen,
			Context nextState, List<Double> lastReward);

	/**
	 * 
	 * Called of the problem is terminated
	 * 
	 */
	void terminate();
}
