package animatlab.kodamat.reinforcementlearning.model.forest;

import animatlab.kodamat.core.trees.Tree;

/**
 * 
 * Policy to work on the reward when extracted from a model
 * 
 */
public interface RewardAdjustmentPolicy {
	/**
	 * 
	 * Adjust a reward function. May create a new function
	 * 
	 * @param action
	 *          action associated with the reward
	 * @param reward
	 *          the reward function extracted from the forest
	 * 
	 * @return the reward function adjusted
	 * 
	 */
	Tree<Double> adjust(String action, Tree<Double> reward);
}