/*
 * 
 * Created on Jan 17, 2006
 *
 */
package animatlab.kodamat.reinforcementlearning.planning;

import java.util.Set;

import animatlab.kodamat.core.IModel;
import animatlab.kodamat.core.functions.IFunction;
import animatlab.kodamat.core.io.ILog;

/**
 * 
 * Interface for planning algorithms
 * 
 * @author Thomas Degris
 * 
 */
public interface IPlanning extends ILog {
	/**
	 * 
	 * @return an optimal policy computed by the planning algorithm
	 * 
	 */
	IFunction<Set<String>> getOptimalPolicy();

	/**
	 * 
	 * @return the optimal value function
	 * 
	 */
	IFunction<Double> getOptimalValueFunction();

	/**
	 * 
	 * @return the name of the algorithm used in planning
	 * 
	 */
	String getName();

	/**
	 * 
	 * @return the model used by the agent
	 * 
	 */
	IModel getModel();

	/**
	 * 
	 * Run the planning algorithm to compute an optimal value function and policy
	 * 
	 */
	void solve();
}
