package animatlab.kodamat.reinforcementlearning.planning.guestrin;

import animatlab.kodamat.core.functions.IPartitionFunction;
import animatlab.kodamat.core.rules.PlainRules;

/**
 * 
 * Policy used to compute Guestrin backprojections
 * 
 * @author Thomas Degris
 * 
 */
public interface GuestrinPolicy {
	/**
	 * 
	 * Compute the back projection for a basis function (Guestrin thesis, page
	 * 127, eq 7.1)
	 * 
	 * @param a
	 *          the action to compute the back projection for
	 * @param basisFunction
	 *          the basis function to project
	 * 
	 * @return the result of the back projection
	 * 
	 */
	abstract public PlainRules<Double> rulesBackProj(String a,
			IPartitionFunction<Double> basisFunction);

	/**
	 * 
	 * @return the name of this policy
	 * 
	 */
	public String getName();
}
