package animatlab.kodamat.reinforcementlearning.planning.guestrin.linearprogramming;

/**
 * 
 * Comment in the constraint declaration
 * 
 * @author Thomas Degris
 * 
 */
public class LPComment extends LPConstraintLine {
	/**
	 * 
	 * Size of the longest comment
	 * 
	 */
	static int commentSize = 0;

	/**
	 * 
	 * String specifying the comment
	 * 
	 */
	public final String comment;

	/**
	 * 
	 * Constructor
	 * 
	 * @param comment
	 *          comment to insert in the constraint declaration
	 * 
	 */
	public LPComment(String comment) {
		super(false);
		this.comment = comment;
		String[] splitted = comment.split("\\n");
		for (String line : splitted) {
			commentSize = Math.max(commentSize, line.length());
		}
	}

	/**
	 * @see animatlab.kodamat.reinforcementlearning.planning.guestrin.linearprogramming.LPConstraintLine#toLPString()
	 */
	@Override
	public CharSequence toLPString() {
		StringBuilder result = new StringBuilder();
		String[] splitted = comment.split("\\n");
		for (String line : splitted) {
			if (line.length() > 0) {
				result.append("\\* " + line);
				for (int index = 0; index < commentSize - line.length(); index++) {
					result.append(" ");
				}
				result.append(" *\\\n");
			}
		}
		return result.substring(0, result.length() - 1);
	}
}
