package animatlab.kodamat.reinforcementlearning.planning.guestrin.linearprogramming;

/**
 * 
 * Base class for a line in the constraints declaration
 * 
 * @author Thomas Degris
 * 
 */
public abstract class LPConstraintLine {
	/**
	 * 
	 * True if this constraint line is a constraint
	 * 
	 */
	public final boolean isConstraint;

	/**
	 * 
	 * Constructor
	 * 
	 * @param isConstraint
	 *          true if this line is a constaint
	 * 
	 */
	LPConstraintLine(boolean isConstraint) {
		this.isConstraint = isConstraint;
	}

	/**
	 * 
	 * @return the LP representation of this constraint
	 * 
	 */
	abstract public CharSequence toLPString();

}
