package animatlab.kodamat.reinforcementlearning.planning.guestrin.linearprogramming;

/**
 * 
 * Variable in the LP definition
 * 
 * @author Thomas Degris
 * 
 */
abstract public class LPVariable {
	/**
	 * 
	 * Solution to the variable
	 * 
	 */
	protected double solution = Double.NaN;

	/**
	 * 
	 * Constructor
	 * 
	 */
	public LPVariable() {
		super();
	}

	/**
	 * 
	 * @return Returns the solution.
	 * 
	 */
	public final double getSolution() {
		return solution;
	}

	/**
	 * 
	 * Set solution
	 * 
	 * @param solution
	 *          The solution to set.
	 * 
	 */
	public final void setSolution(double solution) {
		this.solution = solution;
	}

	/**
	 * 
	 * @return true if this variable is solved
	 * 
	 */
	public final boolean isSolved() {
		return (!Double.isNaN(solution));
	}

	/**
	 * 
	 * @return a string representation of this variable in the LP program
	 * 
	 */
	public abstract String toLPString();

	/**
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		return result.toString();
	}
}
