package animatlab.kodamat.reinforcementlearning.planning.guestrin.linearprogramming;

/**
 * 
 * Represent a weighted named variable
 * 
 * @author Thomas Degris
 * 
 */
public class LPWeightedVariable extends LPNamedVariable {
	/**
	 * 
	 * The weighted variable
	 * 
	 */
	private final LPNamedVariable variable;

	/**
	 * 
	 * The value of the weight
	 * 
	 */
	private final double value;

	/**
	 * 
	 * Constructor
	 * 
	 * @param value
	 *          the value of the weight
	 * @param variable
	 *          the weighted variable
	 * 
	 */
	public LPWeightedVariable(Double value, LPNamedVariable variable) {
		super(variable.name);
		this.variable = variable;
		this.value = value;
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return value + "(" + variable.toString() + ")";
	}

	/**
	 * @see animatlab.kodamat.reinforcementlearning.planning.guestrin.linearprogramming.LPVariable#toLPString()
	 */
	@Override
	public String toLPString() {
		if (value == 0) {
			return null;
		}
		if (value == 1.0) {
			return name;
		}
		return value + " " + name;
	}

}
