/*
 * 
 * Created on Oct 10, 2005
 *
 */
package animatlab.kodamat.reinforcementlearning.planning.spisvi.tests;

import java.awt.Point;
import java.util.Random;
import java.util.Set;

import junit.framework.TestCase;
import animatlab.kodamat.core.functions.IFunction;
import animatlab.kodamat.core.io.Log;
import animatlab.kodamat.core.utils.Context;
import animatlab.kodamat.problems.ProblemRunner;
import animatlab.kodamat.problems.mazespace.MazeModel;
import animatlab.kodamat.reinforcementlearning.agent.ModelBasedAgent;
import animatlab.kodamat.reinforcementlearning.core.acting.Greedy;
import animatlab.kodamat.reinforcementlearning.model.forest.AbstractLearningForest;
import animatlab.kodamat.reinforcementlearning.model.forest.VariableActionLearningForest;
import animatlab.kodamat.reinforcementlearning.planning.spisvi.LearningSpiSvi;
import animatlab.kodamat.supervisedlearning.entropy.KSMeasure;
import animatlab.kodamat.supervisedlearning.learningtree.ItiTree;
import animatlab.kodamat.supervisedlearning.learningtree.SID4Tree;
import animatlab.kodamat.supervisedlearning.regression.LeastSquareMeasure;
import animatlab.kodamat.supervisedlearning.regression.StructureLearningMeasure;

/**
 * 
 * Test the SPI/SVI convergence on the Coffee Robot problem
 * 
 * @author Thomas Degris
 * 
 */
public class TestIncrementalSpiSvi extends TestCase {
	// /**
	// *
	// * Test SPI/SVI on a trajectory
	// *
	// **/
	// public void testOnTrajectory() {
	// Trajectory trajectory =
	// new
	// Trajectory(XmlUtils.getRootFromFile("./data/trajectory/trajectory01.xml"));
	// Chi2Measure chi2VariableValueSetVector = new Chi2Measure(14.0);
	// VariableLearningForest learningForest = new VariableLearningForest(
	// trajectory.getActionList(), trajectory.getLegend(),
	// new ID3Tree.Prob<String>(chi2VariableValueSetVector,
	// trajectory.getLegend()),
	// new ID3Tree.Plain<Double>(new LeastSquareMeasure(),
	// trajectory.getLegend()));
	// learningForest.learnFromTrajectory(trajectory, null);
	// SpiSvi planning = new SpiSvi(learningForest);
	// planning.getSVI();
	// }
	//
	// /**
	// *
	// * Test the SVI algorithm
	// *
	// **/
	// public void testShow() {
	// // Run an experiment
	// Random random = new Random(0);
	// StaticForest forest =
	// new
	// StaticForest(XmlUtils.getRootFromFile("data/forests/coffeerobot.forest"));
	// SID4Tree.Prob<String> learningTree = new SID4Tree.Prob<String>(new
	// Chi2Measure(), forest.getLegend());
	// VariableLearningForest learningForest = new VariableLearningForest(
	// forest.getActionList() , forest.getLegend(), learningTree, null);
	// LearningSpiSvi spisvi = new LearningSpiSvi(learningForest);
	// ModelBasedAgent agent = new ModelBasedAgent(spisvi, new
	// EpsilonGreedy(random, forest.getActionList()));
	// ProblemRunner problemRunner = new ProblemRunner(random, forest, agent,
	// Log.sysout);
	// Trajectory trajectoryLearning = new Trajectory(forest);
	// problemRunner.registerListener(trajectoryLearning);
	// problemRunner.runProblem(200);
	// // Dump the trajectory
	// String filename = Parameters.OUTPUT_JUNIT_FOLDER + "/trajectory.xml";
	// XmlUtils.save(trajectoryLearning, null, filename);
	// // Reload the trajectory
	// trajectoryLearning = new Trajectory(XmlUtils.getRootFromFile(filename));
	// // Compute a value function based on the trajectory
	// VariableLearningForest trajectoryForest =
	// new VariableLearningForest(
	// trajectoryLearning.getActionList() , trajectoryLearning.getLegend(),
	// learningTree, null);
	// trajectoryForest.learnFromTrajectory(trajectoryLearning, null);
	// SpiSvi trajectorySpisvi = new SpiSvi(trajectoryForest);
	// SpiSvi learningSpisvi = new SpiSvi(learningForest);
	// // Compare the value function between the experiment and using the
	// trajectory
	// trajectorySpisvi.getSVI();
	// learningSpisvi.getSVI();
	// double supremum =
	// SpiSvi.getSupremumNorm(
	// learningSpisvi.getOptimalValueFunction(),
	// trajectorySpisvi.getOptimalValueFunction());
	// assertTrue(supremum <= 1.0);
	// // Dump the agent experiment
	// spisvi.dump(Parameters.OUTPUT_JUNIT_FOLDER + "/html", "junit");
	// }
	//
	// /**
	// *
	// * Test an incremental svi on a multi valued problem
	// *
	// *
	// **/
	// public void testMultiValued() {
	// final Chi2Measure chi2VariableValueSetVector = new Chi2Measure(40.0);
	// testMultiValuedOnTreeLearningAlgorithm(new
	// SID5RTree(chi2VariableValueSetVector, null));
	// testMultiValuedOnTreeLearningAlgorithm(new
	// ID4Tree.Prob<String>(chi2VariableValueSetVector, null));
	// }
	//	
	// /**
	// *
	// * Test an incremental svi on a multi valued problem
	// *
	// * @param learningTree the learning tree algorithm to use
	// *
	// **/
	// private void testMultiValuedOnTreeLearningAlgorithm(LearningTree<String,
	// IProbabilities<String>> learningTree) {
	// Random random = new Random(0);
	// StaticForest forest = new
	// StaticForest(XmlUtils.getRootFromFile("data/forests/multivalued.forest"));
	// learningTree.setLegend(forest.getLegend());
	// VariableLearningForest learningForest = new VariableLearningForest(
	// forest.getActionList() , forest.getLegend(), learningTree, null);
	// LearningSpiSvi planning = new LearningSpiSvi(learningForest);
	// FactoredRmaxExplorationPolicy exploration =
	// new FactoredRmaxExplorationPolicy(learningForest, 10, random,
	// forest.getActionList());
	// ModelBasedAgent agent = new ModelBasedAgent(planning, exploration);
	// ProblemRunner problemRunner = new ProblemRunner(random, forest, agent,
	// Log.sysout);
	// problemRunner.runProblem(3000);
	// IFunction<Set<String>> optimalPolicy = planning.getOptimalPolicy();
	// assertEquals(true, optimalPolicy.classify(States.getState("stop,
	// a")).contains("changeV0"));
	// assertEquals(true, optimalPolicy.classify(States.getState("stop,
	// b")).contains("changeV0"));
	// assertEquals(true, optimalPolicy.classify(States.getState("stop,
	// c")).contains("changeV0"));
	// assertEquals(true, optimalPolicy.classify(States.getState("stop,
	// d")).contains("changeV0"));
	//
	// assertEquals(true, optimalPolicy.classify(States.getState("run,
	// a")).contains("changeV1"));
	// assertEquals(true, optimalPolicy.classify(States.getState("run,
	// b")).contains("changeV1"));
	// assertEquals(true, optimalPolicy.classify(States.getState("run,
	// c")).contains("changeV1"));
	// assertEquals(true, optimalPolicy.classify(States.getState("run,
	// d")).contains("changeV1"));
	// }
	//	
	// /**
	// *
	// * Test the incremental learning tree based planning
	// *
	// **/
	// public void testIncrementalLTB() {
	// StaticSpiSvi spisvi =
	// new
	// StaticSpiSvi(XmlUtils.getRootFromFile("data/forests/coffeerobot.spisvi.agent"));
	// LearningTreeBasedPlanning ltbp = new
	// LearningTreeBasedPlanning(spisvi.getModel());
	//
	// ArrayList<String>[] stateSet = States.createStateSet(spisvi.getModel());
	// for (int iteration = 0; iteration < 80; iteration++) {
	// for (ArrayList<String> state : stateSet) {
	// for (String action : spisvi.getModel().getActionList()) {
	// ltbp.getIncrementalPlanning(state, action, null, null);
	// }
	// System.out.println();
	// }
	// }
	//		
	// Tree<Double> treeV = spisvi.getOptimalValueFunction();
	// for (ArrayList<String> state : stateSet) {
	// double max = 0;
	// for (String action : spisvi.getModel().getActionList()) {
	// max = Math.max(max, ltbp.getActionValueFunction(action).classify(state));
	// }
	// double expected = treeV.classify(state);
	// assertTrue(Math.abs(expected - max) <
	// Parameters.EPSILON_THRESHOLD_CONVERGENCE);
	// }
	// }

	/**
	 * 
	 * Value function of the maze defined by Sutton
	 * 
	 */
	static private final String SUTTON_MAZE_POLICY_FUNCTION[][] = {
			{ "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX" },
			{ "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX" },
			{ "XXXXXXXXXXXX", "XXXXXXXXXXXX", "         [2]", "         [2]",
					"         [2]", "      [2, 1]", "      [2, 1]", "      [2, 1]",
					"         [1]", "XXXXXXXXXXXX", "[3, 2, 1, 0]", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX" },
			{ "XXXXXXXXXXXX", "XXXXXXXXXXXX", "   [3, 2, 1]", "      [3, 1]",
					"XXXXXXXXXXXX", "      [2, 1]", "      [2, 1]", "      [2, 1]",
					"         [1]", "XXXXXXXXXXXX", "         [3]", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX" },
			{ "XXXXXXXXXXXX", "XXXXXXXXXXXX", "      [2, 1]", "         [1]",
					"XXXXXXXXXXXX", "      [2, 1]", "      [2, 1]", "      [2, 1]",
					"         [1]", "XXXXXXXXXXXX", "         [3]", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX" },
			{ "XXXXXXXXXXXX", "XXXXXXXXXXXX", "      [2, 1]", "         [1]",
					"XXXXXXXXXXXX", "         [2]", "         [2]", "         [2]",
					"         [2]", "         [2]", "         [3]", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX" },
			{ "XXXXXXXXXXXX", "XXXXXXXXXXXX", "         [2]", "         [2]",
					"         [2]", "      [3, 2]", "         [3]", "XXXXXXXXXXXX",
					"      [3, 2]", "      [3, 2]", "         [3]", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX" },
			{ "XXXXXXXXXXXX", "XXXXXXXXXXXX", "      [3, 2]", "      [3, 2]",
					"      [3, 2]", "      [3, 2]", "      [3, 2]", "         [2]",
					"      [3, 2]", "      [3, 2]", "         [3]", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX" },
			{ "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX" },
			{ "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX", "XXXXXXXXXXXX",
					"XXXXXXXXXXXX" } };

	/**
	 * 
	 * Representation of a wall
	 * 
	 */
	static final String WALL = "XXXXXXXXXXXX";

	/**
	 * 
	 * Get a string representation of a value function
	 * 
	 * @param valueFunction
	 *          the value function to represent into a string
	 * 
	 * @return a string representing the value function
	 * 
	 */
	protected String getStringRepresentation(String[][] valueFunction) {
		final String wall = "XXXXXXXXXXXX";
		StringBuffer result = new StringBuffer();
		result.append("{ \n");
		for (int y = 0; y < valueFunction.length; y++) {
			result.append("{ ");
			for (int x = 0; x < valueFunction[0].length; x++) {
				result.append("\"");
				String actionRepresentation;
				if (valueFunction[y][x].length() == 0) {
					actionRepresentation = wall;
				} else {
					actionRepresentation = valueFunction[y][x];
				}
				for (int index = actionRepresentation.length(); index < wall.length(); index++) {
					result.append(" ");
				}
				result.append(actionRepresentation);
				result.append("\"");
				if (x < (valueFunction[0].length - 1)) {
					result.append(", ");
				}
			}
			result.append("}");
			if (y < (valueFunction.length - 1)) {
				result.append(",\n");
			}
		}
		result.append("}");
		return result.toString();
	}

	/**
	 * 
	 * Get the state corresponding to a position in the maze
	 * 
	 * @param mazeModel
	 *          maze to get the state from
	 * @param currentPosition
	 *          the position in the maze
	 * 
	 * @return the state corresponding to currentPosition
	 * 
	 */
	private Context getState(MazeModel mazeModel, Point currentPosition) {
		Context state = new Context();
		mazeModel.setState(currentPosition, state);
		return state;
	}

	/**
	 * 
	 * Test the convergence of the value function in the maze
	 * 
	 */
	@SuppressWarnings("unchecked")
	public void testPolicyFunctionConvergence() {
		final MazeModel mazeModel = new MazeModel(MazeModel.SUTTON_MAZE,
				MazeModel.SUTTON_SIMPLE);
		ItiTree learningTree = new ItiTree(new KSMeasure(), mazeModel
				.getVariableOrdering());
		AbstractLearningForest learningForest = new VariableActionLearningForest(
				mazeModel.getActionList(), mazeModel.getVariableOrdering(),
				learningTree, new SID4Tree.Plain<Double>(new StructureLearningMeasure(
						1, 1, null), mazeModel.getVariableOrdering()));
		learningForest.setIncludeActionInRewardLearningFlag(true);
		LearningSpiSvi planning = new LearningSpiSvi(learningForest);
		planning.setOrdering(new LeastSquareMeasure(null));
		planning.setResetRewardFlag(false);
		ModelBasedAgent agent = new ModelBasedAgent(planning, new Greedy(
				new Random(0), mazeModel.getActionList()));
		ProblemRunner problemRunner = new ProblemRunner(null, mazeModel, agent,
				Log.sysout);
		problemRunner.runProblem(325);
		Point currentPosition = new Point();
		IFunction<Set<String>> greedyPolicy = planning.getCurrentOptimalPolicy();
		Set<String>[][] expectedValueFunction = new Set[mazeModel.getDimension().height][mazeModel
				.getDimension().width];
		for (currentPosition.x = 0; currentPosition.x < mazeModel.getDimension().width; currentPosition.x++) {
			for (currentPosition.y = 0; currentPosition.y < mazeModel.getDimension().height; currentPosition.y++) {
				String expectedValue = SUTTON_MAZE_POLICY_FUNCTION[currentPosition.y][currentPosition.x];
				if (!WALL.equals(expectedValue)) {
					expectedValueFunction[currentPosition.y][currentPosition.x] = greedyPolicy
							.classify(getState(mazeModel, currentPosition));
				} else {
					expectedValueFunction[currentPosition.y][currentPosition.x] = null;
				}
			}
		}
		for (currentPosition.x = 0; currentPosition.x < mazeModel.getDimension().width; currentPosition.x++) {
			for (currentPosition.y = 0; currentPosition.y < mazeModel.getDimension().height; currentPosition.y++) {
				Set<String> actionSet = expectedValueFunction[currentPosition.y][currentPosition.x];
				if (actionSet != null) {
					for (String action : expectedValueFunction[currentPosition.y][currentPosition.x]) {
						assertEquals(
								true,
								SUTTON_MAZE_POLICY_FUNCTION[currentPosition.y][currentPosition.x]
										.contains(action));
					}
				}
			}
		}
	}
}
