/*
 * 
 * Created on 15 nov. 2005
 *
 */
package animatlab.kodamat.reinforcementlearning.planning.stats;

import static animatlab.kodamat.reinforcementlearning.agent.ModelBasedAgent.TIME_POINTS_LEARNING;
import static animatlab.kodamat.reinforcementlearning.agent.ModelBasedAgent.TIME_POINTS_PLANNING;

import java.util.Map;

import animatlab.kodamat.core.utils.Chrono;
import animatlab.kodamat.reinforcementlearning.agent.ModelBasedAgent;
import animatlab.kodamat.reinforcementlearning.core.stats.Measure;

/**
 * 
 * Measure logging the used to compute learning and planning
 * 
 * @author Thomas Degris
 * 
 */
public class ComputationTimeMeasure extends Measure {
	/**
	 * 
	 * Constructor
	 * 
	 */
	public ComputationTimeMeasure() {
		super();
	}

	/**
	 * @see animatlab.kodamat.reinforcementlearning.core.stats.Measure#computeMeasures(Map)
	 */
	@Override
	public void computeMeasures(Map<String, Double> data) {
		if (!(agent instanceof ModelBasedAgent)) {
			return;
		}
		Chrono chrono = ((ModelBasedAgent) agent).getChrono();
		if (chrono.getTimePoint(TIME_POINTS_LEARNING) != null) {
			data.put("tl", chrono.getTimePoint(TIME_POINTS_LEARNING));
		}
		if (chrono.getTimePoint(TIME_POINTS_PLANNING) != null) {
			data.put("tp", chrono.getTimePoint(TIME_POINTS_PLANNING));
		}
	}

	/**
	 * @see animatlab.kodamat.reinforcementlearning.core.stats.Measure#reset()
	 */
	@Override
	public void reset() {
		// Nothing to reset
	}
}
