/*
 * 
 * Created on 24 dec. 2005
 *
 */
package animatlab.kodamat.supervisedlearning.core;

import animatlab.kodamat.core.proba.ILearningProbabilities;

/**
 * 
 * Interface used for a tree able to learn from examples classified
 * 
 * @param <T>
 *          type of object classified
 * 
 * @author Thomas Degris
 * 
 */
public interface ISupervisedLearning<T> extends Cloneable {
	/**
	 * 
	 * Learn an exemple
	 * 
	 * @param example
	 *          the example to learn
	 * 
	 */
	public void learn(Example<T> example);

	/**
	 * 
	 * @return some stats on all the examples learned
	 * 
	 */
	public ILearningProbabilities<T> getStats();

	/**
	 * 
	 * Learns all remaining examples
	 * 
	 */
	public void flush();
}
