/*
 * 
 * Created on Dec 27, 2005
 *
 */
package animatlab.kodamat.tests;

import junit.framework.Test;
import junit.framework.TestSuite;
import animatlab.kodamat.core.adds.tests.TestADDs;
import animatlab.kodamat.core.conditions.test.TestStateCondition;
import animatlab.kodamat.core.io.Log;
import animatlab.kodamat.core.proba.tests.TestProba;
import animatlab.kodamat.core.rules.tests.TestRulesSet;
import animatlab.kodamat.core.trees.test.TestDecisionTrees;
import animatlab.kodamat.experiments.test.TestExperiment;
import animatlab.kodamat.problems.generated.syntheticmdps.tests.TestSyntheticMdps;
import animatlab.kodamat.problems.generated.sysadmin.tests.TestSysAdminGeneratedProblem;
import animatlab.kodamat.problems.tests.TestFactory;
import animatlab.kodamat.reinforcementlearning.model.forest.test.TestDeterministicLearningForest;
import animatlab.kodamat.reinforcementlearning.model.forest.test.TestForestLoading;
import animatlab.kodamat.reinforcementlearning.model.forest.test.TestLearningForest;
import animatlab.kodamat.reinforcementlearning.planning.guestrin.tests.TestGuestrin;
import animatlab.kodamat.reinforcementlearning.planning.spisvi.tests.TestIncrementalSpiSvi;
import animatlab.kodamat.reinforcementlearning.planning.spisvi.tests.TestSpiSvi;
import animatlab.kodamat.reinforcementlearning.planning.spudd.test.TestSpudd;
import animatlab.kodamat.reinforcementlearning.planning.stats.tests.TestLearningForestStatistics;
import animatlab.kodamat.supervisedlearning.test.TestRegressionTree;

/**
 * 
 * Run all sdyna tests
 * 
 * @author Thomas Degris
 * 
 */
public class AllTests {
	/**
	 * 
	 * @return the test suite regrouping all SDyna tests
	 * 
	 */
	public static Test suite() {
		Log.sysout = new Log("./.reports/alltests.log");

		TestSuite suite = new TestSuite("Test for animatlab.kodamat.sdyna");
		suite.addTestSuite(TestDecisionTrees.class);
		suite.addTestSuite(TestRulesSet.class);
		suite.addTestSuite(TestADDs.class);
		suite.addTestSuite(TestProba.class);
		suite.addTestSuite(TestDeterministicLearningForest.class);
		suite.addTestSuite(TestRegressionTree.class);
		suite.addTestSuite(TestLearningForestStatistics.class);
		suite.addTestSuite(TestStateCondition.class);
		suite.addTestSuite(TestForestLoading.class);
		suite.addTestSuite(TestSysAdminGeneratedProblem.class);
		suite.addTestSuite(TestSyntheticMdps.class);
		suite.addTestSuite(TestSpiSvi.class);
		suite.addTestSuite(TestGuestrin.class);
		suite.addTestSuite(TestSpudd.class);
		suite.addTestSuite(TestFactory.class);
		suite.addTestSuite(TestLearningForest.class);
		suite.addTestSuite(TestExperiment.class);
		suite.addTestSuite(TestIncrementalSpiSvi.class);
		return suite;
	}

}
